# coding: utf-8

"""
    Capital Flows 1.0.0

    Capital flows are the cash and asset subscriptions coming into a fund and the cash and asset redemptions going out of a fund (e.g., client contributions, withdrawals, and initial funding for a portfolio). This API permits users to validate, create, update, and receive capital flows transactions and their details. User needs standard API permissison ALADDIN_API_USER to use the Capital Flows API and standard newcash permissions to perform different actions. Please refer to the Capital Flows User Guide on the client landing page for more information on newcash permission structure.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class EnumsAction(str, Enum):
    """
    Represents capital flow lifecycle transition actions.   - ACTION_UNSPECIFIED: Represents unspecified action.  - ACTION_AUTHORIZE: Represents authorize action.  - ACTION_CONFIRM: Represents confirm action.  - ACTION_UNCONFIRM: Represents unconfirm action.  - ACTION_REQUEST_CANCEL: Represents request cancel action.  - ACTION_AUTHORIZE_CANCEL: Represents authorize cancel action.  - ACTION_REJECT_CANCEL: Represents reject cancel action.  - ACTION_CANCEL: Represents cancel action.  - ACTION_RESET: Represents reset action.  - ACTION_FINALISE: Represents finalise action.
    """

    """
    allowed enum values
    """
    ACTION_UNSPECIFIED = 'ACTION_UNSPECIFIED'
    ACTION_AUTHORIZE = 'ACTION_AUTHORIZE'
    ACTION_CONFIRM = 'ACTION_CONFIRM'
    ACTION_UNCONFIRM = 'ACTION_UNCONFIRM'
    ACTION_REQUEST_CANCEL = 'ACTION_REQUEST_CANCEL'
    ACTION_AUTHORIZE_CANCEL = 'ACTION_AUTHORIZE_CANCEL'
    ACTION_REJECT_CANCEL = 'ACTION_REJECT_CANCEL'
    ACTION_CANCEL = 'ACTION_CANCEL'
    ACTION_RESET = 'ACTION_RESET'
    ACTION_FINALISE = 'ACTION_FINALISE'

    @classmethod
    def from_json(cls, json_str: str) -> EnumsAction:
        """Create an instance of EnumsAction from a JSON string"""
        return EnumsAction(json.loads(json_str))


