# coding: utf-8

"""
    Capital Flows 1.0.0

    Capital flows are the cash and asset subscriptions coming into a fund and the cash and asset redemptions going out of a fund (e.g., client contributions, withdrawals, and initial funding for a portfolio). This API permits users to validate, create, update, and receive capital flows transactions and their details. User needs standard API permissison ALADDIN_API_USER to use the Capital Flows API and standard newcash permissions to perform different actions. Please refer to the Capital Flows User Guide on the client landing page for more information on newcash permission structure.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class EnumsCapitalFlowBasis(str, Enum):
    """
    Describes the basis of capital flow record.   - CAPITAL_FLOW_BASIS_UNSPECIFIED: Represents unspecified basis.  - CAPITAL_FLOW_BASIS_UNIT: Represents unit basis.  - CAPITAL_FLOW_BASIS_CASH: Represents cash basis.  - CAPITAL_FLOW_BASIS_SELL_ALL: Represents sell all basis.  - CAPITAL_FLOW_BASIS_TEMPORARY: Represents temporary basis.  - CAPITAL_FLOW_BASIS_PERCENT: Represents percent basis.
    """

    """
    allowed enum values
    """
    CAPITAL_FLOW_BASIS_UNSPECIFIED = 'CAPITAL_FLOW_BASIS_UNSPECIFIED'
    CAPITAL_FLOW_BASIS_UNIT = 'CAPITAL_FLOW_BASIS_UNIT'
    CAPITAL_FLOW_BASIS_CASH = 'CAPITAL_FLOW_BASIS_CASH'
    CAPITAL_FLOW_BASIS_SELL_ALL = 'CAPITAL_FLOW_BASIS_SELL_ALL'
    CAPITAL_FLOW_BASIS_TEMPORARY = 'CAPITAL_FLOW_BASIS_TEMPORARY'
    CAPITAL_FLOW_BASIS_PERCENT = 'CAPITAL_FLOW_BASIS_PERCENT'

    @classmethod
    def from_json(cls, json_str: str) -> EnumsCapitalFlowBasis:
        """Create an instance of EnumsCapitalFlowBasis from a JSON string"""
        return EnumsCapitalFlowBasis(json.loads(json_str))


