# coding: utf-8

"""
    Capital Flows 1.0.0

    Capital flows are the cash and asset subscriptions coming into a fund and the cash and asset redemptions going out of a fund (e.g., client contributions, withdrawals, and initial funding for a portfolio). This API permits users to validate, create, update, and receive capital flows transactions and their details. User needs standard API permissison ALADDIN_API_USER to use the Capital Flows API and standard newcash permissions to perform different actions. Please refer to the Capital Flows User Guide on the client landing page for more information on newcash permission structure.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class EnumsEstimateState(str, Enum):
    """
    Describes estimated state of capital flow. (*Required).   - ESTIMATE_STATE_UNSPECIFIED: Represents unspecified estimated state.  - ESTIMATE_STATE_ESTIMATED: Represents estimated state as estimated.  - ESTIMATE_STATE_FINAL: Represents estimated state as final.
    """

    """
    allowed enum values
    """
    ESTIMATE_STATE_UNSPECIFIED = 'ESTIMATE_STATE_UNSPECIFIED'
    ESTIMATE_STATE_ESTIMATED = 'ESTIMATE_STATE_ESTIMATED'
    ESTIMATE_STATE_FINAL = 'ESTIMATE_STATE_FINAL'

    @classmethod
    def from_json(cls, json_str: str) -> EnumsEstimateState:
        """Create an instance of EnumsEstimateState from a JSON string"""
        return EnumsEstimateState(json.loads(json_str))


