# coding: utf-8

"""
    Capital Flows 1.0.0

    Capital flows are the cash and asset subscriptions coming into a fund and the cash and asset redemptions going out of a fund (e.g., client contributions, withdrawals, and initial funding for a portfolio). This API permits users to validate, create, update, and receive capital flows transactions and their details. User needs standard API permissison ALADDIN_API_USER to use the Capital Flows API and standard newcash permissions to perform different actions. Please refer to the Capital Flows User Guide on the client landing page for more information on newcash permission structure.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class EnumsTrueUp(str, Enum):
    """
    Describes the true-up analysis of capital flow record.   - TRUE_UP_UNSPECIFIED: Represents unspecified true up.  - TRUE_UP_NOT_STARTED: Represents not started true up.  - TRUE_UP_FA_PRICES_APPLIED_DEPENDENCY: Represents fund accountant prices applied - Dependency true up  - TRUE_UP_FA_PRICES_APPLIED: Represents fund accountant prices applied true up  - TRUE_UP_DEALING_PRICES_APPLIED_DEPENDENCY: Represents dealing prices applied - Dependency true up  - TRUE_UP_DEALING_PRICES_APPLIED: Represents dealing prices applied true up.  - TRUE_UP_PRICED: Represents priced true up.
    """

    """
    allowed enum values
    """
    TRUE_UP_UNSPECIFIED = 'TRUE_UP_UNSPECIFIED'
    TRUE_UP_NOT_STARTED = 'TRUE_UP_NOT_STARTED'
    TRUE_UP_FA_PRICES_APPLIED_DEPENDENCY = 'TRUE_UP_FA_PRICES_APPLIED_DEPENDENCY'
    TRUE_UP_FA_PRICES_APPLIED = 'TRUE_UP_FA_PRICES_APPLIED'
    TRUE_UP_DEALING_PRICES_APPLIED_DEPENDENCY = 'TRUE_UP_DEALING_PRICES_APPLIED_DEPENDENCY'
    TRUE_UP_DEALING_PRICES_APPLIED = 'TRUE_UP_DEALING_PRICES_APPLIED'
    TRUE_UP_PRICED = 'TRUE_UP_PRICED'

    @classmethod
    def from_json(cls, json_str: str) -> EnumsTrueUp:
        """Create an instance of EnumsTrueUp from a JSON string"""
        return EnumsTrueUp(json.loads(json_str))


